﻿Option Strict On
Imports Un4seen.Bass
Imports Un4seen.Bass.Misc

Imports System.Timers
Imports System.Windows.Input
Imports System.Windows.Threading
Imports DialogFensterTest2.ViewModel.Instrastructure
Imports DialogFensterTest2.ViewModel.Services
Imports Microsoft.WindowsAPICodePack.Dialogs
Imports System.IO
Imports System.Net
Imports System.Windows
Imports System.Drawing
Imports System.Windows.Media
Imports System.Windows.Media.Imaging

Public Class MainViewModel
    Inherits ViewModel.Instrastructure.ViewModelBase
    Private _stream As Integer
    Private MeinTimer As New DispatcherTimer
    Private MeineWellenForm As New WaveForm
    Private WellenForm As Bitmap
    Private Zoom As Integer = 10
    Private IsDrawing As Boolean = False

    Public Sub New()


        'Breite = 500
        'Hoehe = 100

    End Sub

    Private _DialogOeffnen As ICommand
    Public ReadOnly Property DialogOeffnen() As ICommand
        Get
            If _DialogOeffnen Is Nothing Then _DialogOeffnen = New RelayCommand(AddressOf OKDialogOeffnen_Execute, Function(o) True)
            Return _DialogOeffnen
        End Get
    End Property
    Private Sub OKDialogOeffnen_Execute(obj As Object)
        Dim Objekt = DirectCast(obj, String)
        Dim dialogService = ServiceContainer.GetService(Of IDialogWindowService)
        Dim fensterService = ServiceContainer.GetService(Of IWindowService)
        Select Case Objekt

            Case "WaveForm"
                Debug.WriteLine("Breite: " & Breite)
                Debug.WriteLine("Höhe: " & Hoehe)
                Bass.BASS_Init(-1, 44100, BASSInit.BASS_DEVICE_CPSPEAKERS, IntPtr.Zero, Nothing)
                'Breite = 500
                'Hoehe = 100
                _stream = Bass.BASS_StreamCreateFile("", 0, 0, BASSFlag.BASS_DEFAULT Or BASSFlag.BASS_STREAM_AUTOFREE Or BASSFlag.BASS_SAMPLE_FLOAT)   'hier musst du noch den Pfad einer MP3 Datei eingeben als erstes Argument
                Bass.BASS_ChannelPlay(_stream, False)
                MeinTimer.Interval = TimeSpan.FromMilliseconds(20)
                AddHandler MeinTimer.Tick, AddressOf UpdateVisualization

                MeineWellenForm = New WaveForm("")   'hier musst du noch den Pfad der selben MP3 Datei eingeben als Argument
                MeineWellenForm.ColorBackground = System.Drawing.Color.Black

                MeineWellenForm.RenderStart(True, BASSFlag.BASS_SAMPLE_FLOAT Or BASSFlag.BASS_STREAM_PRESCAN Or BASSFlag.BASS_DEFAULT)
                MeineWellenForm.SyncPlayback(_stream)
                WellenForm = New Bitmap(MeineWellenForm.CreateBitmap(Breite, Hoehe, -1, -1, True))
                WaveFormSource = BitmapToImageSource(WellenForm)
                MeinTimer.Start()
        End Select
    End Sub

    Private Sub UpdateVisualization(ByVal sender As Object, ByVal e As EventArgs)

        Dim ChannelLaenge As Long = Bass.BASS_ChannelGetLength(_stream, BASSMode.BASS_POS_BYTES)
        Dim ChannelPosition As Long = Bass.BASS_ChannelGetPosition(_stream, BASSMode.BASS_POS_BYTES)
        Dim bpp As Double = ChannelLaenge / Breite / Zoom
        Dim TrackPosition As Integer = CInt(Math.Round(ChannelPosition / bpp))
        XPosition = (TrackPosition * -1) + (Breite \ 2)
        If WellenForm IsNot Nothing Then
            WellenForm = New Bitmap(MeineWellenForm.CreateBitmap(Breite, Hoehe, -1, -1, True))
            WaveFormSource = BitmapToImageSource(WellenForm)
        End If
        Debug.WriteLine("Breite: " & CStr(Breite))
        Debug.WriteLine("XPosition: " & CStr(XPosition))
    End Sub

    Private Sub InitialisiereWaveForm()
        'MeineWellenForm = New WaveForm("C:\Users\alpha\Music\hiphop\american\Eminem\Eminem - The Marshall Mathers LP\03 Eminem ft. Dido - The Marshall Mathers LP - Stan.mp3", New WAVEFORMPROC(AddressOf MeineWellenFormCallBackFuntion), Nothing)
        MeineWellenForm = New WaveForm("C:\Users\alpha\Music\hiphop\american\Eminem\Eminem - The Marshall Mathers LP\03 Eminem ft. Dido - The Marshall Mathers LP - Stan.mp3")
        MeineWellenForm.FrameResolution = 0.01F
        ''WF.FrameResolution = 0.02
        'MeineWellenForm.CallbackFrequency = 500
        MeineWellenForm.ColorBackground = System.Drawing.Color.Black
        MeineWellenForm.ColorLeft = System.Drawing.Color.FromArgb(64, 64, 50)
        MeineWellenForm.ColorLeft = System.Drawing.Color.Aquamarine
        MeineWellenForm.ColorLeftEnvelope = System.Drawing.Color.Aquamarine
        MeineWellenForm.ColorMiddleLeft = System.Drawing.Color.Aquamarine
        MeineWellenForm.DrawCenterLine = True
        MeineWellenForm.DrawEnvelope = False
        MeineWellenForm.DetectBeats = True
        MeineWellenForm.BeatLength = 1.0
        MeineWellenForm.BeatWidth = 2
        MeineWellenForm.DrawBeat = WaveForm.BEATDRAWTYPE.TopBottom
        MeineWellenForm.ColorBeat = System.Drawing.Color.Yellow
        MeineWellenForm.DrawMarker = WaveForm.MARKERDRAWTYPE.Line Or WaveForm.MARKERDRAWTYPE.Name Or WaveForm.MARKERDRAWTYPE.NamePositionMiddle
        MeineWellenForm.DrawWaveForm = WaveForm.WAVEFORMDRAWTYPE.Mono
        MeineWellenForm.RenderStart(True, BASSFlag.BASS_SAMPLE_FLOAT Or BASSFlag.BASS_STREAM_PRESCAN Or BASSFlag.BASS_DEFAULT)
        MeineWellenForm.SyncPlayback(_stream)
    End Sub

    Private Sub MeineWellenFormCallBackFunktion(ByVal framesDone As Integer, ByVal framesTotal As Integer, ByVal elapsedTime As TimeSpan, ByVal finished As Boolean)
        ZeichneWellenForm(False)
        If finished Then
            ZeichneWellenForm(True)
        End If
    End Sub

    Private _Breite As Integer
    Public Property Breite As Integer
        Get
            Return _Breite
        End Get
        Set(value As Integer)
            _Breite = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _Hoehe As Integer
    Public Property Hoehe As Integer
        Get
            Return _Hoehe
        End Get
        Set(value As Integer)
            _Hoehe = value
            RaisePropertyChanged()
        End Set
    End Property

    Private _WaveFormSource As ImageSource
    Public Property WaveFormSource As ImageSource
        Get
            Return _WaveFormSource
        End Get
        Set(value As ImageSource)
            _WaveFormSource = value
            RaisePropertyChanged()
        End Set
    End Property

    Private Function BitmapToImageSource(ByVal bitmap As Bitmap) As BitmapImage
        Using memory As MemoryStream = New MemoryStream()
            bitmap.Save(memory, System.Drawing.Imaging.ImageFormat.Bmp)
            memory.Position = 0
            Dim bitmapimage As BitmapImage = New BitmapImage()
            bitmapimage.BeginInit()
            bitmapimage.StreamSource = memory
            bitmapimage.CacheOption = BitmapCacheOption.OnLoad
            bitmapimage.EndInit()
            Return bitmapimage
        End Using
    End Function

    Private Sub ZeichneWellenForm(Optional ByVal HighQuality As Boolean = False)
        If HighQuality = False Then
            IsDrawing = Not IsDrawing
            If IsDrawing Then Exit Sub
        End If
        If Not WellenForm Is Nothing Then
            'WaveImg = New Bitmap(MeineWellenForm.CreateBitmap(Breite * Zoom, Hoehe, -1, -1, HighQuality))
            WellenForm = New Bitmap(MeineWellenForm.CreateBitmap(Breite * Zoom, Hoehe, -1, -1, HighQuality))
            WaveFormSource = BitmapToImageSource(WellenForm)

            If MeineWellenForm.IsRenderingInProgress Then Exit Sub
        Else
            WaveFormSource = Nothing
        End If

    End Sub

    Private _XPosition As Integer
    Public Property XPosition As Integer
        Get
            Return _XPosition
        End Get
        Set(value As Integer)
            _XPosition = value
            RaisePropertyChanged()
        End Set
    End Property

    Private ReadOnly Property X_1 As Integer
        Get
            Return Breite \ 2 * Zoom
        End Get
    End Property


End Class
